#ifndef _consumer
#define _consumer

#include <systemc.h>

SC_MODULE(consumer)
{
	sc_in<bool > clock;
	sc_in<bool > reset_n;

	sc_in<sc_uint<8> > data_s; 	//sent data
	sc_in<bool > req;
	sc_out<bool > ack;

	sc_out<sc_uint<8> > data_r;	//received data
	sc_out<bool > valid;		//valid data line at the output of consumer

	void proc_consumer();

	SC_CTOR(consumer)
	{
		SC_METHOD(proc_consumer);
		sensitive << reset_n.neg();
		sensitive << clock.pos();
	}
};

#endif
