#include "producer.h"
#include "consumer.h"
#include "reseter.h"

int sc_main(int argc, char* argv[])
{
	sc_clock clockSgn("myClock");
	sc_signal<bool > rst_n_sgn;

	sc_signal<sc_uint<8> > data_s;	// data signal sent from Producer to Consumer
	sc_signal<bool > req;			// request signal sent from Producer to Consumer
	sc_signal<bool > ack;			// ack signal sent from Consumer to Producer

	sc_signal<sc_uint<8> > data_r;	// data signal sent from Consumer to outside world
	sc_signal<bool > valid;			// valid data signal sent from Consumer to outside world

//
	reseter myReseter("myReseter");
	myReseter.inclock(clockSgn);
	myReseter.reset_n(rst_n_sgn);

	producer myProducer("myProducer");
	myProducer.clock(clockSgn);
	myProducer.reset_n(rst_n_sgn);
	myProducer.data_s(data_s);
	myProducer.req(req);
	myProducer.ack(ack);

	consumer myConsumer("myConsumer");
	myConsumer.clock(clockSgn);
	myConsumer.reset_n(rst_n_sgn);
	myConsumer.data_s(data_s);
	myConsumer.req(req);
	myConsumer.ack(ack);
	myConsumer.data_r(data_r);
	myConsumer.valid(valid);

	sc_trace_file *tf = sc_create_vcd_trace_file("Prod_Cons_Res");
	sc_trace(tf, rst_n_sgn, "reset");
	sc_trace(tf, clockSgn, "clock");

	sc_trace(tf, data_s, "data_s");
	sc_trace(tf, req, "req");
	sc_trace(tf, ack, "ack");

	sc_trace(tf, data_r, "data_r");
	sc_trace(tf, valid, "valid");

	sc_start(100,SC_NS);		// simulate for 100ns

	sc_close_vcd_trace_file(tf);

	return 0;
}

