#ifndef _reseter
#define _reseter

#include <systemc.h>

//Modulo que produz o sinal de reset do sistema
SC_MODULE(reseter)
{
	// external interface
	sc_in<bool > inclock;
	sc_out<bool > reset_n;

	// a 3-bit counter
	sc_uint<3> counter;

	//modulo responsavel por gerar o reset
	void reset_gen();

	//comandos chamados ao iniciar
	SC_CTOR(reseter)
	{
		// inicializando counter
		counter=0;

		// dispara o metodo que gera o reset
		SC_METHOD(reset_gen);

		// metodo sensvel ao sinal inclock
		sensitive << inclock.pos();
	}

};

#endif
